//
// Copyright 2006 Mentor Graphics Corporation
//
// All Rights Reserved.
//
// THIS WORK CONTAINS TRADE SECRET AND PROPRIETARY INFORMATION WHICH IS THE PROPERTY
// OF MENTOR GRAPHICS CORPORATION OR ITS LICENSORS AND IS SUBJECT TO LICENSE TERMS.
//

`timescale 1 ns / 1 ns

module memory(pmbus.bus_m m0);
    `define addr_size 8
    `define word_size 16

    logic [`word_size-1:0] data_r;
    logic rdy_r;

    initial begin
        data_r = 'bz;
        rdy_r = 1;
    end

    assign #(5) m0.DATA = data_r, m0.RDY = rdy_r;

    reg [`word_size-1:0] mem[0:(1 << `addr_size) - 1];

    integer i;
    always @(posedge m0.CLK) if (m0.STRB == 0) begin
        i = m0.ADDR;
        if (m0.RW == 1) begin
            repeat (4) @(posedge m0.CLK);
            data_r = mem[i];
            rdy_r = 0;
            @(posedge m0.CLK)
            data_r = 'bz;
            rdy_r = 1;
        end else begin
            repeat (2) @(posedge m0.CLK);
            mem[i] = m0.DATA;
            rdy_r = 0;
            @(posedge m0.CLK)
            rdy_r = 1;
        end
    end
endmodule   
